
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Android 5.0中的蓝牙BLE / iVAN</title>

    <meta name="description" content="Android 5.0中的蓝牙BLE 一.蓝牙BLE(Bluetooth Low Energy)介绍概要 蓝牙低能耗(BLE)技术是低成本.短距离.可互操作的鲁棒性无线技术,工作在免许可的2.4GHz ISM射频频段.它从一开始就设计为超低功耗(ULP)无线技术. 蓝牙低能耗技术的三大特性成就了ULP性能,这三大特性分别是最大化的待机时间.快速连接和低峰值的发送/接收功耗. 无线&quot;开启&quot;的时间只要不是很短就会令电池寿命急剧降低,因此任何必需的发送或接收任务需要很快完成.被蓝牙低能耗技术用来最小化无线开启时间的第一 ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Android 5.0中的蓝牙BLE</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>一、蓝牙BLE(Bluetooth Low Energy)介绍概要</p>
<p>蓝牙低能耗(BLE)技术是低成本、短距离、可互操作的鲁棒性无线技术，工作在免许可的2.4GHz ISM射频频段。它从一开始就设计为超低功耗(ULP)无线技术。</p>
<p>蓝牙低能耗技术的三大特性成就了ULP性能，这三大特性分别是最大化的待机时间、快速连接和低峰值的发送/接收功耗。</p>
<p>无线“开启”的时间只要不是很短就会令电池寿命急剧降低，因此任何必需的发送或接收任务需要很快完成。被蓝牙低能耗技术用来最小化无线开启时间的第一个技巧是仅用3个“广告”信道搜索其它设备，或向寻求建立连接的设备宣告自身存在。相比之下，标准蓝牙技术使用了32个信道。</p>
<p>蓝牙低能耗技术“完成”一次连接(即扫描其它设备、建立链路、发送数据、认证和适当地结束)只需3ms。而标准蓝牙技术完成相同的连接周期需要数百毫秒。再次提醒，无线开启时间越长，消耗的电池能量就越多。</p>
<p>二、关键概念：</p>
<p>（1）Generic Attribute Profile (GATT)</p>
<p>通过BLE连接，读写属性类小数据的Profile通用规范。现在所有的BLE应用Profile都是基于GATT的。</p>
<p>（2）Attribute Protocol (ATT)</p>
<p>GATT是基于ATT Protocol的。ATT针对BLE设备做了专门的优化，具体就是在传输过程中使用尽量少的数据。每个属性都有一个唯一的UUID，属性将以characteristics and services的形式传输。</p>
<p>（3）Characteristic</p>
<p>Characteristic可以理解为一个数据类型，它包括一个value和0至多个对次value的描述（Descriptor）。</p>
<p>（4）Descriptor</p>
<p>对Characteristic的描述，例如范围、计量单位等。</p>
<p>（5）Service</p>
<p>Characteristic的集合。例如一个service叫做“Heart Rate Monitor”，它可能包含多个Characteristics，其中可能包含一个叫做“heart rate measurement"的Characteristic。</p>
<p>三、相关权限</p>
<pre>
&lt;uses-permission android:name="android.permission.BLUETOOTH" /&gt;</pre>
<pre>
&lt;!-- 允许程序进行发现和配对新的蓝牙设备 --&gt;</pre>
<pre>
&lt;uses-permission android:name="android.permission.BLUETOOTH_ADMIN" /&gt;</pre>
<pre>
&lt;uses-feature android:name="android.hardware.bluetooth_le" android:required="true"/&gt;</pre>
<pre>
public class BluetoothBleDemo extends Activity {
    private static final int REQUEST_CODE_BLUETOOTH_ENABLE = 1;
    private static final int SCAN_PERIOD = 10000;

    private BluetoothAdapter bluetoothAdapter;
    //import android.bluetooth.le.ScanCallback;
    private ScanCallback scanCallback = new ScanCallback() {
        @Override
        public void onBatchScanResults(List&lt;ScanResult&gt; results) {
            //Batch 一批
        }

        @Override
        public void onScanResult(int callbackType, ScanResult result) {
            switch(callbackType) {
                case ScanSettings.CALLBACK_TYPE_ALL_MATCHES:
                    break;
                case ScanSettings.CALLBACK_TYPE_FIRST_MATCH:
                    break;
                case ScanSettings.CALLBACK_TYPE_MATCH_LOST:
                    break;
            }

            BluetoothDevice device = result.getDevice();
            String deviceName = device.getName();
            String deviceAddress = device.getAddress();
            int deviceType = device.getType();
            ParcelUuid[] deviceUuids = device.getUuids();
            int deviceBondState = device.getBondState();

            ScanRecord scanRecord = result.getScanRecord();
            int advertiseFlags = scanRecord.getAdvertiseFlags();
            //txPowerLevel 发射功率等级
			//URL：http://www.bianceng.cn/OS/extra/201608/50410.htm
            int txPowerLevel = scanRecord.getTxPowerLevel();
            String recordDeviceName = scanRecord.getDeviceName();
            List&lt;ParcelUuid&gt; serviceUuids = scanRecord.getServiceUuids();
            Map&lt;ParcelUuid, byte[]&gt; serviceData = scanRecord.getServiceData();

            //RSSI 信号强度,可以用来测算距离
            int rssi = result.getRssi();
            long timestampNanos = result.getTimestampNanos();
        }

        @Override
        public void onScanFailed(int errorCode) {

        }
    };
    private BluetoothGattCallback gattCallback = new BluetoothGattCallback() {
        @Override
        public void onServicesDiscovered(BluetoothGatt gatt, int status) {
            super.onServicesDiscovered(gatt, status);
        }

        @Override
        public void onCharacteristicChanged(BluetoothGatt gatt, BluetoothGattCharacteristic characteristic) {
            super.onCharacteristicChanged(gatt, characteristic);
        }

        @Override
        public void onCharacteristicRead(BluetoothGatt gatt, BluetoothGattCharacteristic characteristic, int status) {
            super.onCharacteristicRead(gatt, characteristic, status);
        }

        @Override
        public void onCharacteristicWrite(BluetoothGatt gatt, BluetoothGattCharacteristic characteristic, int status) {
            super.onCharacteristicWrite(gatt, characteristic, status);
        }

        @Override
        public void onConnectionStateChange(BluetoothGatt gatt, int status, int newState) {
            super.onConnectionStateChange(gatt, status, newState);
        }

        @Override
        public void onDescriptorRead(BluetoothGatt gatt, BluetoothGattDescriptor descriptor, int status) {
            super.onDescriptorRead(gatt, descriptor, status);
        }

        @Override
        public void onDescriptorWrite(BluetoothGatt gatt, BluetoothGattDescriptor descriptor, int status) {
            super.onDescriptorWrite(gatt, descriptor, status);
        }

        @Override
        public void onMtuChanged(BluetoothGatt gatt, int mtu, int status) {
            super.onMtuChanged(gatt, mtu, status);
        }

        @Override
        public void onReadRemoteRssi(BluetoothGatt gatt, int rssi, int status) {
            super.onReadRemoteRssi(gatt, rssi, status);
        }

        @Override
        public void onReliableWriteCompleted(BluetoothGatt gatt, int status) {
            super.onReliableWriteCompleted(gatt, status);
        }
    };
    private Handler handler = new Handler() {
        @Override
        public void handleMessage(Message msg) {
        }
    };

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        //判断是否支持BLE特性
        if(getPackageManager().hasSystemFeature(PackageManager.FEATURE_BLUETOOTH_LE)) {
            initBluetoothBle();
        } else {
            showToast("this device can not support Bluetooth BLE");
        }
    }

    private void initBluetoothBle() {
        //BluetoothAdapter是Android系统中所有蓝牙操作都需要的，它对应本地Android设备的蓝牙模块，在整个系统中BluetoothAdapter是单例的。当你获取到它的示例之后，就能进行相关的蓝牙操作了。
        //BluetoothManager在Android4.3以上支持(API level 18)
        BluetoothManager bluetoothManager = (BluetoothManager) getSystemService(Context.BLUETOOTH_SERVICE);
        bluetoothAdapter = bluetoothManager.getAdapter();
    }

    /**
     * 开启蓝牙
     * 打开和关闭蓝牙模块, 都可以通过ACTION_STATE_CHANGED广播来监听
     */
    private void requestEnable() {
        //第一种方法打开蓝牙, 没有任何提示, 直接就打开了
        //boolean result = bluetoothAdapter.enable();
        //第二种方法发送广播, 会弹出一个对话框, 选择是否打开蓝牙, 选择是蓝牙才打开;
        if(bluetoothAdapter != null &amp;&amp; !bluetoothAdapter.isEnabled()) {
            Intent intent = new Intent(BluetoothAdapter.ACTION_REQUEST_ENABLE);
            startActivityForResult(intent, REQUEST_CODE_BLUETOOTH_ENABLE);
        }
    }

    /**
     * 扫描BLE设备.注意该方法无法扫描标准蓝牙,只能扫描BLE设备
     */
    private void scanBleDevice(final boolean enabled) {
        if(bluetoothAdapter == null) {
            return;
        }
        /*
        为什么不能再使用单例的BluetoothAdapter? 原因如下:
        bluetoothAdapter.startLeScan() //deprecated
        http://stackoverflow.com/questions/30223071/startlescan-replacement-to-current-api
        Remember that the method: public BluetoothLeScanner getBluetoothLeScanner () isn't static.
        If you do: BluetoothAdapter.getBluetoothLeScanner()
        you will get an error, since getDefaultAdapter() is a static method, but getBluetoothLeScanner() isn't.
        You need an instance of a BluetoothAdapter.
         */
        final BluetoothLeScanner scanner = bluetoothAdapter.getBluetoothLeScanner();
        if(enabled) {
            //scan分为2类,而在android L之前,搜索条件只有uuid
            //(1)直接搜索全部周围peripheral(外围的)设备,搜索结果将通过这个callback返回
            scanner.startScan(scanCallback);
            //(2)根据过滤条件搜索设备
            final List&lt;ScanFilter&gt; scanFilters = new ArrayList&lt;ScanFilter&gt;();
            //uuid格式8-4-4-4-12(32位,128bit)
            //address格式(12位,48bit)
            scanFilters.add(new ScanFilter.Builder().setServiceUuid(ParcelUuid.fromString("00000000-0000-0000-0000-000000000000")).setDeviceAddress("00:00:00:00:00:00").build());
            ScanSettings scanSettings = new ScanSettings.Builder()
                    //require API 23
                    //.setCallbackType(0).setMatchMode(0).setNumOfMatches(0)
                    .setReportDelay(0).setScanMode(BluetoothAdapter.SCAN_MODE_CONNECTABLE_DISCOVERABLE).build();
            scanner.startScan(scanFilters, scanSettings, scanCallback);
            handler.postDelayed(new Runnable() {
                @Override
                public void run() {
                    scanner.stopScan(scanCallback);
                }
            }, SCAN_PERIOD);
        } else {
            scanner.stopScan(scanCallback);
        }
    }

    /**
     * 两个设备通过BLE通信，首先需要建立GATT连接。这里我们讲的是Android设备作为client端，连接GATT Server。数据发送方向总是从server推送到client
     */
    private void connectToGATTServer(BluetoothDevice device) {
        //函数成功，返回BluetoothGatt对象，它是GATT profile的封装。通过这个对象，我们就能进行GATT Client端的相关操作。BluetoothGattCallback用于传递一些连接状态及结果。
        BluetoothGatt bluetoothGatt = device.connectGatt(this, false, gattCallback);

        //连接远程设备
        boolean connectResult = bluetoothGatt.connect();
        //搜索连接设备所支持的service
        boolean discoverResult = bluetoothGatt.discoverServices();
        //断开与远程设备的GATT连接
        bluetoothGatt.disconnect();
        //关闭GATT Client端
        bluetoothGatt.close();
        //读取指定的characteristic。
        //boolean readResult = bluetoothGatt.readCharacteristic(characteristic);
        //设置当指定characteristic值变化时，发出通知
        //boolean setResult = bluetoothGatt.setCharacteristicNotification(characteristic, enabled);
        //获取远程设备所支持的services
        List&lt;BluetoothGattService&gt; gattServices = bluetoothGatt.getServices();
    }

    private void showToast(String msg) {
        Toast.makeText(this, msg, Toast.LENGTH_SHORT).show();
    }

}</pre>
<p>以上是小编为您精心准备的的内容，在的博客、问答、公众号、人物、课程等栏目也有的相关内容，欢迎继续使用右上角搜索按钮进行搜索蓝牙<br />
                    ，                scanner<br />
                    ，                android 5.0错误<br />
                    ，                close() scanner java<br />
                    ，                ble<br />
                    ，                android5.0<br />
                    ，                android5.0闪退<br />
                    ，                android 蓝牙<br />
                    ，                android  权限 5.0<br />
                    ，                override<br />
                    ，                public<br />
                    ，                蓝牙uuid<br />
                    ，                设备<br />
                    ，                status<br />
                                    void<br />
                                    android 5.0 蓝牙、android5.0 蓝牙开发、蓝牙5.0、蓝牙5.0芯片、蓝牙5.0标准，以便于您获取更多的相关知识。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 08:55:49</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/public/" title="public">public</a>, <a href="https://www.iamivan.net/tag/%e8%ae%be%e5%a4%87/" title="设备">设备</a>, <a href="https://www.iamivan.net/tag/status/" title="status">status</a>, <a href="https://www.iamivan.net/tag/void/" title="void">void</a>, <a href="https://www.iamivan.net/tag/scanner/" title="scanner">scanner</a>, <a href="https://www.iamivan.net/tag/%e8%93%9d%e7%89%99/" title="蓝牙">蓝牙</a>, <a href="https://www.iamivan.net/tag/android-5-0%e9%94%99%e8%af%af/" title="android 5&period;0错误">android 5&period;0错误</a>, <a href="https://www.iamivan.net/tag/android5-0/" title="Android5&period;0">Android5&period;0</a>, <a href="https://www.iamivan.net/tag/override/" title="override">override</a>, <a href="https://www.iamivan.net/tag/%e8%93%9d%e7%89%99uuid/" title="蓝牙uuid">蓝牙uuid</a>, <a href="https://www.iamivan.net/tag/close-scanner-java/" title="close&lpar;&rpar; scanner java">close&lpar;&rpar; scanner java</a>, <a href="https://www.iamivan.net/tag/ble/" title="ble">ble</a>, <a href="https://www.iamivan.net/tag/android5-0%e9%97%aa%e9%80%80/" title="android5&period;0闪退">android5&period;0闪退</a>, <a href="https://www.iamivan.net/tag/android-%e8%93%9d%e7%89%99/" title="android 蓝牙">android 蓝牙</a>, <a href="https://www.iamivan.net/tag/android-%e6%9d%83%e9%99%90-5-0/" title="android  权限 5&period;0">android  权限 5&period;0</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Android 5.0中的蓝牙BLE的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/vbQPPOz.html" rel="bookmark">图片-android 4&period;0中 WebP不显示问题（不考虑4&period;0以下系统）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 android 4.0中 WebP不显示问题(不考虑4.0以下系统) 由于图片太大,我们项目中使用了webp格式的图片,在适配三星s2,4.0系统的时候出现了这种问题,部分webp图片可以显示,一部分webp图片不显示,但是在4.3以上的手机测试时都没有问题,不知道怎么回事,有没有大神帮解答下!谢谢! 解决方案 Android4.0 Toast显示问题Android 4.0 系统语言预设问题android 4.0 显示系统			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pPkoeDM.html" rel="bookmark">我的Android进阶之旅------&amp;amp&semi;gt&semi;如何解决Android 5&period;0中出现的警告： Service Intent must be explicit&colon;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				我的Android进阶之旅--&gt;如何解决Android 5.0中出现的警告: java.lang.IllegalArgumentException: Service Intent must be explicit: Intent { act=com.xtc.kuwo.watch.MUSIC_PLAY_SERVICE (has extras) } 1.错误描述 今天在Android4.4 的小米4手机上运行我的程序的时候没有报错,而在Android 5.1的华为P7上运行我的程序的时候报了以下的错			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pPkoQrM.html" rel="bookmark">avd空白-我新装的Android Studio2&period;0中为何模拟器中是空白？求解决。</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 我新装的Android Studio2.0中为何模拟器中是空白?求解决. 希望给出明确解释,并流图说明! 我完全新装的从Android官网下载的... 解决方案 Android Studio 2.0新模拟器尝鲜Android模拟器2.0初探 解决方案二: http://www.oschina.net/question/2471276_2134084 解决方案三: 是不是没有镜像文件啊 解决方案四: 要先创建 下载系统 解决方案五: 需要吗?我有,要的话回我			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bEJXg6M.html" rel="bookmark">谷歌员工证实Bable服务将会整合到Android 5&period;0中</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				&amp;http://www.aliyun.com/zixun/aggregation/37954.html&quot;&gt;nbsp;   上周,一张据说是来自谷歌内部的应用截图被 曝光在互联网上,传言表示谷歌将会在未来整合旗下所有具有通讯功能的服务到统一平台,形成一种统一的服务.据悉这种服务将会被谷歌整合到下一代Android 5.0 Key Lime Pie酸橙派操作系统中.     一位来自谷歌的内部员工已经证实,这项名为&quot;Google Bable&quot;的服务不仅将会被整合到A			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MN245mM.html" rel="bookmark">Android 7&period;0中新签名对多渠道打包的影响详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				老签名多渠道打包原理 前言 由于Android7.0发布了新的签名机制,加强了签名的加固,导致在新的签名机制下无法通过美团式的方式再继续打多渠道包了.不过在说新的签名机制对打包方案的 影响和为什么会影响我们原有的打包机制之前,需要先简单理解下打包原理和签名在整个打包过程中的作用. Android打包流程 Android打包过程大致如图所示,整个流程就是将Java代码,资源文件以及第三方库整合成一个Apk文件,并对整合后的文件进行签名和优化对齐.整个过程可以简 单分为以下几个步骤: 资源预编译 为			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M69WDgb.html" rel="bookmark">Android 7&period;0中拍照和图片裁剪适配的问题详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 Android 7.0系统发布后,拿到能升级的nexus 6P,就开始了7.0的适配.发现在Android 7.0以上,在相机拍照和图片裁剪上,可能会碰到以下一些错误: Process: com.yuyh.imgsel, PID: 22995 // 错误1 android.os.FileUriExposedException: file:///storage/emulated/0/Android/data/com.yuyh.imgsel/cache/1486438962645.jpg ex			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pdmlP4z.html" rel="bookmark">Android 5&period;0中CoordinatorLayout的使用技巧&lowbar;Android</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				CoordinatorLayout 实现了多种Material Design中提到的滚动效果.目前这个框架提供了几种不用写动画代码就能工作的方法,这些效果包括: *让浮动操作按钮上下滑动,为Snackbar留出空间. *扩展或者缩小Toolbar或者头部,让主内容区域有更多的空间. *控制哪个view应该扩展还是收缩,以及其显示大小比例,包括视差滚动效果动画. 浮动操作按钮与Snackbar CoordinatorLayout可以用来配合浮动操作按钮的 layout_anchor 和 layou			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bojEx3z.html" rel="bookmark">Android 5&period;0中CoordinatorLayout的使用技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				CoordinatorLayout 实现了多种Material Design中提到的滚动效果.目前这个框架提供了几种不用写动画代码就能工作的方法,这些效果包括: *让浮动操作按钮上下滑动,为Snackbar留出空间. *扩展或者缩小Toolbar或者头部,让主内容区域有更多的空间. *控制哪个view应该扩展还是收缩,以及其显示大小比例,包括视差滚动效果动画. 浮动操作按钮与Snackbar CoordinatorLayout可以用来配合浮动操作按钮的 layout_anchor 和 layou			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/boa2WBp.html" rel="bookmark">Android 5&period;0 中Activity切换效果动画介绍及例</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				动画效果图如下: 下面要介绍的其中一种Activity的切换效果(如上图).当前后两个Activity有共同的UI元素时候,适合用这种动画效果,给用户连贯性的体验.   实现步骤 1. 新建一个Android应用Project,里面有两个Activity; 2. 下面是MainActivity的代码和XML布局;    代码和布局都非常简单.解释一下onClick()方法的代码.    makeSceneTransactionAnimation()方法第二个参数是用来告诉指定共同的UI元素是哪一			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qbamO2b.html" rel="bookmark" class="title">提高内存使用效能的技巧</a>
					<div>
						尽管现在计算机的内存一般都比较大,一般都有1GB的内存,有的甚至达到2GB.4GB,但是由于用户运行的软件本身较大,或者打开的文件窗口较多,或者上网时打开的窗口较多,也会影响系统运行的速度,严重地将会 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/jbE9Xob.html" rel="bookmark" class="title">关于jsp环境配置及Bean的设置</a>
					<div>
						js 我也是一个新手,只是把这二天在碰到的问题写出来,给其它和我同样的行者提供参考,由于是初学者,对许多概念,名词难免有许多不足之处,请指出并给予见谅.关键字:JSP  TOMCAT 配置  环境   ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/6b3vxNz.html" rel="bookmark" class="title">不要局限于PageRank：逐渐选择其它可操作性指标</a>
					<div>
						与所有拥有丰富好奇心的网友一样,我也设置了 Google快讯,每当我的名字在网上被提及时,我都会收到相关电子邮件.通常,我会零零散散地收到一些关于我的论坛发帖. 博客文章和 Twitter消息的提示邮 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7k1d4z.html" rel="bookmark" class="title">Oracle的网络配置参数</a>
					<div>
						Oracle数据库在不同的地域被人们广泛使用,所以就必须要有专业的Oracle人员懂得网络连接是怎么样影响数据库性能的.Oracle提供的 TNS允许在每个数据库中进行分配通信.TNS服务器被看作Or ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/balvlQz.html" rel="bookmark" class="title">BCB6命令行工具简介</a>
					<div>
						BCB6有很多命令行工具. 下面简要的作一个介绍: BCC32.EXE C++32位编译程序 BPR2MAK.EXE 转换XML文件格式为MAKE文件格式 BRC32.EXE 32位资源编辑程序 BR ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvKLN6p.html" rel="bookmark" class="title">我的WCF之旅（1）：创建一个简单的WCF程序</a>
					<div>
						写在前面 在Microsoft提出.NET战略以来, 先后推出了一系列产品和技术, 这些产品和技术为我们在.NET平台下建立企业级的分布式应用提供了很大的 便利.这些技术和产品包括:.NET Remo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pd78k4M.html" rel="bookmark" class="title">浅谈Java中的类型转换</a>
					<div>
						要说类型转换,首先要说一说java的数据类型.java中的数据类型分为两种:基本类型.引用类型.基本数据类型没有什么好说的byte char short int long float double b ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJ7LGJb.html" rel="bookmark" class="title">php生成RSS订阅的方法</a>
					<div>
						 本文实例讲述了php生成RSS订阅的方法.分享给大家供大家参考.具体分析如下: RSS(简易信息聚合,也叫聚合内容)是一种描述和同步网站内容的格式.RSS可以是以下三个解释的其中一个: Really ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlR7lYz.html" rel="bookmark" class="title">在CentOS上安装Percona服务器的方法</a>
					<div>
						  在这篇文章中我们将了解关于 Percona 服务器,一个开源的MySQL,MariaDB的替代品.InnoDB的数据库引擎使得Percona 服务器非常有吸引力,如果你需要的高性能,高可靠性和高性 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6edxOb.html" rel="bookmark" class="title">迅雷快鸟使用教程</a>
					<div>
						  关键时刻总是掉链子,看球时候突然缓冲这样的情况相信大家时常发生,别担心迅雷上网加速器迅雷快鸟正式发布了,那么问题来了迅雷快鸟怎么用?下面小编就为大家详细介绍迅雷快鸟使用教程. 迅雷快鸟怎么用 首先 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEWvvAp.html" rel="bookmark" class="title">关于文件写入的原子性讨论</a>
					<div>
						​   文件的写入是否是原子的?多个线程写入同一个文件是否会写错乱?多个进程写入同一个文件是否会写错乱?想必这些问题多多少少会对我们产生一定的困扰,即使知道结果,很多时候也很难将这其中的原理清晰的表达 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3ogLNb.html" rel="bookmark" class="title">Win8&period;1按钮回归</a>
					<div>
						微软今天正式证实,Windows 8.1已经完成制作,并将发布RTM版本.这意味着硬件制造商们将可以为这一版本的系统优化硬件.Windows RT 8.1将于10月18号正式发布,正在使用Window ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9YxE4M.html" rel="bookmark" class="title">ajax-ASP&period;NET AJAX控件问题。</a>
					<div>
						问题描述 ASP.NET AJAX控件问题. 我使用的是AjaxControlToolKit里的LineChart,用VS2010浏览可以正常显示曲线图,如下图: 发布到IIS6.0后访问,无法显示曲 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRDxVxz.html" rel="bookmark" class="title">AM335x&lpar;TQ335x&rpar;学习笔记&mdash;&mdash;WM8960声卡驱动移植</a>
					<div>
						经过一段时间的调试,终于调好了TQ335x的声卡驱动.TQ335x采用的Codec是WM8960,本文来总结下WM8960驱动在AM335x平台上的移植方法.Linux声卡驱动架构有OSS和ALSA两 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXqYYWz.html" rel="bookmark" class="title">如何构建一个高效的数据科学部门</a>
					<div>
						这篇文章在Hacker News转载后产生很热烈的讨论,主要是从工程师的角度来看问题,讨论了很多有关人员管理和团队分工等一些很现实的问题.不是所有人都同意文中的观点和解决方案,也有很多人写出了自己的经 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDerwWb.html" rel="bookmark" class="title">Kafka&plus;Storm&plus;HDFS整合实践</a>
					<div>
						在基于Hadoop平台的很多应用场景中,我们需要对数据进行离线和实时分析,离线分析可以很容易地借助于Hive来实现统计分析,但是对于实时的需求Hive就不合适了.实时应用场景可以使用Storm,它是一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq7mqez.html" rel="bookmark" class="title">很简单的一个问题的一个问题&comma;请大家赐教</a>
					<div>
						问题描述 在C/S程序里面开发一个系统,经常会遇到这样的界面布局:工具栏:新增编辑删除列表:...................................................... ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYN2rxp.html" rel="bookmark" class="title">张近东居零售首富宝座苏宁市值达国美近三倍</a>
					<div>
						&quot;零售大王&quot;张近东以财富304亿元第三次荣登&quot;胡润零售富豪榜&quot;首富宝座:黄光裕家族以财富160亿元位居其次. 汽车销售成为新一个重点零售行业.百货零售有10人上 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmVAvBz.html" rel="bookmark" class="title">js实现StringBuffer的简单实例&lowbar;javascript技巧</a>
					<div>
						实现: function StringBuffer() { this.__strings__ = []; }; StringBuffer.prototype.Append = function (st ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pL53YZz.html" rel="bookmark" class="title">今天收到支票，说说我的建站经历，想要双喜临门</a>
					<div>
						做站缘由:我一高中同学,跟我特要好的那种,高考的时候志愿报的都一样,可惜后来他高考失误,没有在一个学校了.大学期间也断断续续联系.毕业的时候问他找啥工作.他说在在家里单干,搞网站.当时我已经在我现在的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0NEeDz.html" rel="bookmark" class="title">网站制作建设Web前端设计排版技巧</a>
					<div>
						一.强调字体 字体的设计与强调在网页当中相当重要,合适的排版和适当的字体强调,不仅可以让用户快速的抓住网站中的重点,同样可以增强网站对用户的吸引力 二.单页面设计 随着互联网的发展,用户的习惯更倾向于 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7QKZRM.html" rel="bookmark" class="title">api-vfp6&period;0中需要调用java编写的网页</a>
					<div>
						问题描述 vfp6.0中需要调用java编写的网页 vfp6.0中需要调用java编写的网页,需要用api调用,但是vfp调用api的代码找不到,请问怎么调用java,项目时间紧张,不考虑代码改写,谢 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn8JYkb.html" rel="bookmark" class="title">Mac OS X 10&period;9 应用无法启动，提示&OpenCurlyDoubleQuote;来自身份不明的开发者&rdquo;问题解决</a>
					<div>
						Mac OS X 10.9 应用无法启动,提示&quot;来自身份不明的开发者&quot;问题解决 太阳火神的美丽人生 (http://blog.csdn.net/opengl_es) 本文遵循&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zG1rXEM.html" rel="bookmark" class="title">苹果质保服务延长至两年 售后或低头</a>
					<div>
						[赛迪网讯]9月25日消息,著名业内网站ZDNET 刊登题为&lt;苹果延保服务AppleCare+出重大改进,苹果售后或&quot;低头&quot; &gt;的报道,现全文摘要 如下:苹果公司在千呼 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mrv5LxM.html" rel="bookmark" class="title">mongoDB&amp;&num;039&semi;s Capped Collections</a>
					<div>
						在mongoDB中有一个非常好用的collection : Capped Collections.这种Collection可以设置最大的extent size或max documents,除此之外,在 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7wVodz.html" rel="bookmark" class="title">门户通：免费的大旗能扛多久</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 门户通从刚刚推出到现在,虽然只有短 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pk7Xqyp.html" rel="bookmark" class="title">网易真的是不可能违规遵纪守法的好公司吗？</a>
					<div>
						不久前网易&lt;魔兽世界&gt;项目负责人李日强在接受新浪科技采访时表示&quot;网易一个正规公司,不可能违规,暴雪也不会违法&quot;(http://tech.sina.com.cn/i/20 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mxgd9jb.html" rel="bookmark" class="title">网络推广：从执行者到决策者的转变</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 这些天来,一直在思考一个问题,也是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/baElaQb.html" rel="bookmark" class="title">php获取服务器端mac和客户端mac的地址支持WIN&sol;LINUX&lowbar;php技巧</a>
					<div>
						获取服务器mac 复制代码 代码如下: &lt;?php /** 获取网卡的MAC地址原码:目前支持WIN/LINUX系统 获取机器网卡的物理(MAC)地址 **/ class GetmacAddr{ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mr7qRvp.html" rel="bookmark" class="title">GoDaddy 2013年4月优惠码：全场优惠35&percnt;</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 最新更新:GoDaddy的2013 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.032 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
